<?php

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

/**
* Author Tab Class for handling the CB tab api
* @package Community Builder
* @author Viper (Tamas DAJKA - viper@vipernet.hu)
* @copyright: Viper
*
* If you like it, please donate: paypal://viper@buli.net
*
* 2007.02.27.
*
*/
class getUserSReviewsTab extends cbTabHandler {
	
	function getReviewsTab() {
		$this->cbTabHandler();
	}
	
	function getDisplayTab($tab,$user,$ui) {
		InitReviewsEngine();
		$text = UserSComments($user->id,$this->params);
		return PrepareContent($text);
	} //getDisplayTab
}	// end class getAuthorTab.

function PrepareContent($mytext) {
	global $_MAMBOTS;
	
	/* Process Mambots */
	$row =& new mosContent($database);
	$row->text = $mytext;

	$params = new mosParameters( '' );   // fake params
	// process the new bots
	$_MAMBOTS->loadBotGroup( 'content' );
	$result = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$params, 0 ), true );	
	return  $row->text;	
}

function UserSComments($userid,$params) {
 global $database,$settings,$mosConfig_absolute_path,$mode,$criteria_qty;
 
 $ff_compath = $mosConfig_absolute_path."/components/com_facileforms";

 // get url params, load configuration settings and initialize vars
 $start = 1;
 if (!function_exists(xrLoadSettings)) require_once($ff_compath."/xtdratings/xtdratings.common.functions.php");
 if (!is_array($settings) || !isset($settings)) {
  $settings = xrLoadSettings();
 }
 if (!function_exists(xrEstAvgRating)) require_once($ff_compath."/xtdratings/xtdratings.main.functions.php");
 $limit_pag = $settings['all_reviews_fullpage'];
 $user_voting = $settings['user_voting'];
 $name_choice = $settings['name_choice'];
 $plimit = mosGetParam($_REQUEST,'limit',$params->_params->PageLimit);
 $pstart = mosGetParam($_REQUEST,'start',1);
 $porder = mosGetParam($_REQUEST,'order','name');
 $tindex = mosGetParam($_REQUEST,'tindex',false);
 $pagtop = '';
 $pagbottom = '';
 $limit = '';
 $rows_recent = array();
 $average_rating = array();
 $user_section = '';
 $not_in = '';
 if (!isset($mode)) $mode = xrModeExplode();
 //Language finder

 if (isset($settings['lang']))
  $lang = $settings['lang'];
 else
  $lang = $mosConfig_lang;
 if (file_exists($ff_compath.'/xtdratings/languages/'.$lang.'.php'))
  require_once($ff_compath.'/xtdratings/languages/'.$lang.'.php');
 else
  require_once($ff_compath.'/xtdratings/languages/english.php');

 // how many comments for this item? 
 $database->setQuery("SELECT count(*) FROM `#__ff_review_comments` WHERE published='1' AND userid='$userid'");
 $count = $database->loadResult();
 if ($count) {
  $selectfrom = "SELECT a.id, a.pid, a.date, a.userid, a.name, a.location, a.title, a.comments, a.published, b.yes, (b.yes+b.no) as count, a.ratings as rating \n"
	     ."FROM #__ff_review_comments a LEFT JOIN #__ff_review_votes b on a.id = b.reviewid \n";
  // define limits for queries
   $limit = "LIMIT ".($start-1).",".$limit_pag;

  // comments ordered by most recent, limited by $limitnum variable
  $where = "WHERE a.published='1' AND a.userid='$userid' ".$not_in."\n";
  $order = " ORDER BY a.date DESC ";
  $query = $selectfrom.$where.$order.$limit;
  $database->setQuery($query);
  $allrows = $database->loadObjectList();
  $rows_recent = '';
  $ii = (($pstart+$plimit-1) > count($allrows) ? count($allrows) : ($pstart+$plimit-1));
  for ($i=($pstart-1);$i<$ii;$i++) {
  	$rows_recent[] = $allrows[$i];
  }
  foreach ($rows_recent as $row_recent) {
   $product = xrModeProductInfo($row_recent->pid);
   $catid = $product->catid;
   $criteria = xrModeCriteria($catid);
   $criteria_qty = $criteria->qty;
   $row_recent->rating=xrEstAvgRating($row_recent->rating);
  }
  $rows_recent = xrTranslate($rows_recent,'ff_review_comments');
  // generate pagination code
  if ($count>$plimit) {
	$pagination = xrPagCB($count,$pstart,$plimit,$porder,$tindex);
	$pagtop = "<div class=\"pagenav\">$pagination</div><br>";
	$pagbottom = "<div class=\"pagenav\">$pagination</div>";
  }
  // end pagination 
 
  /**************************************/
  /* ORGANIZE AND SEND OUTPUT TO SCREEN */
  /**************************************/
   if($name_choice=='alias')
      $username = ff_selectValue("select username from `#__ff_review_comments` where userid = '$userid' LIMIT 1");
   else
      $username = ff_selectValue("select name from `#__ff_review_comments` where userid = '$userid' LIMIT 1");
   $user_section .= "<tr><td class=\"contentheading\">".$username.XR_USERS_REVIEWS."</td></tr>";
   $user_section .= "<tr><td>".xrBuildCommentTable($rows_recent,$user_voting)."</td></tr>";
   $output =  "<table style=\"vertical-align: top; width=100%;\" width=100%>".
              "{$user_section}</table>";
   $powered = xrCredit();
   $comments =  $pagtop.$output.$pagbottom.$powered;
   if ($tindex) $comments .= '<script>tabPanecb_tabmain.setSelectedIndex('.$tindex.');</script>';
 } else 
   $comments = XR_NO_USER_REVIEWS;
 return $comments;
}

function xrBuildCommentTable ($rows,$voting=0) {
 if (!is_null($rows)) {
  global $settings,$criteria_qty,$database,$Itemid;
  $output = '';
  foreach ($rows as $row) {
   $product = xrModeProductInfo($row->pid);
   //Determine how many criteria are used in this category
   $catid = $product->catid;
   $criteria = xrModeCriteria($catid);
   $criteria_qty = $criteria->qty;
   $product_url = xrSEFurl("index.php?option=com_content&task=view&id=$row->pid&Itemid=$Itemid");
   $output .= "<table width = \"100%\" border = \"0\" padding = \"0\" cellspacing = \"0\">";
   $output .= "<tr>";
   $output .= "<td style=\"vertical-align: bottom; text-align: left;\">";
   $output .= "<div class=\"xr_comment_title1\" style=\"clear:right\"><p>"
             ."<a style=\"font-size:120%; font-weight:bold;\" href=$product_url target='_parent'>$product->title</a></p></div>";
   if ($row->count > 0 && $voting)  //total votes on a particular review
     $output .= "<p>$row->yes ".XR_OF_HELPFUL." $row->count ".XR_FOUND_HELPFUL."</p>"; 
   $output .= "<div class=\"xr_comment_title1\" style=\"clear:right\">"
             .xrDrawStars($row->rating);
   $output .= '<b>&nbsp;'.xrTextWrap($row->title).'</b>, '.mosFormatDate($row->date);
   $output .= "</div>";
   $output .= "</td></tr></table>";
   $output .= "<table width=\"100%\" border=\"0\" padding =\"0\" cellspacing =\"0\">";
   $output .= "<tr><td style=\"vertical-align: top\">";
   if (($criteria_qty>1 && $settings['ratings_chart'])) {
     $output .= "<div class=\"xr_individual_ratings_outer\">".xrRatingFull($row->pid,$row->id)."</div>";
   }
   $output .= xrTextWrap($row->comments);
   $output .= "</td></tr>";
   $output .= "</table>";
   $output = "<div class=\"xr_comments\">$output</div>";
   } // end foreach $rows as $row 
  return $output;
 } else // end if is_null
  return '';
} // end function xrBuildCommentTable


function xrPagCB ($count,$start=1,$limit=10,$order='name',$tindex=false) {
   global $mode;
   $nextstart= $start+$limit;
   $prevstart= $start-$limit;
   if (($nextstart-1) > $count) $endnext = $count;
   else $endnext = $nextstart-1;
   $endprev = $prevstart-1;
	$ttmp = preg_split("/&order/i",$_SERVER['REQUEST_URI'],2);
   $link = 'http://'.$_SERVER['HTTP_HOST'].$ttmp[0];
   $link .= ($order ? "&order=$order" : '');
   $link .= ($limit ? "&limit=$limit" : '');
   $next_link = $link."&start=$nextstart";
   $prev_link = $link."&start=$prevstart";
   $next_url = "<a href=\"$next_link\">".
               XR_NEXT."</a>";
   $prev_url = "<a href=\"$prev_link\">".
               XR_PREVIOUS."</a>";
   $next_link_js = '<a href="#next" onClick="javascript: var nlink; nlink = \''.$next_link.'&tindex=\''.'+ tabPanecb_tabmain.getSelectedIndex(); self.location.href(nlink);">';
   $next_url_js = $next_link_js.XR_NEXT."</a>";
   $prev_link_js = '<a href="#prev" onClick="javascript: var plink; plink = \''.$prev_link.'&tindex=\''.'+ tabPanecb_tabmain.getSelectedIndex(); self.location.href(plink);">';
   $prev_url_js = $prev_link_js.XR_PREVIOUS."</a>";
   $pagination = $start."-".$endnext." of ".$count;
   if ($endnext<$count)
      $pagination .= " | ".$next_url_js;
   if ($start > 1)
      $pagination = $prev_url_js." | ".$pagination; 
   return $pagination;
}

function InitReviewsEngine() {

 if (!function_exists('ff_select')) {
 function ff_select($sql, $error=FF_DIE)
 {
    global $database;
    $database->setQuery($sql);
    $rows = $database->loadObjectList();
    if ($database->getErrorNum()) {
        $dienow = $error==FF_DIE;
        $error = $database->stderr();
        $rows = array();
        if ($dienow) {echo $error; exit;}
    } else
        $error = null;
    return $rows;
 } // ff_select
 }
 // ff_selectValue

 if (!function_exists('ff_selectValue')) {
 function ff_selectValue($sql, $def=null, $error=FF_DIE)
 {
    global $database;
    $database->setQuery($sql);
    $value = $database->loadResult();
    if ($database->getErrorNum()) {
        $dienow = $error==FF_DIE;
        $error = $database->stderr();
        if ($dienow) {echo $error; exit;}
    } else {
        $error = null;
        if ($value) return $value;
    } // if
    return $def;
 } // ff_selectValue
 }
 // ff_query

 if (!function_exists('ff_query')) {
 function ff_query($sql, $insert=false)
 {
    global $database, $ff_processor;
    $database->setQuery($sql);
    $database->query();
    if ($insert) return $database->insertid();
    return 0;
 } // ff_query
 }
}

?>